import { system, world } from '@minecraft/server'
import { ActionFormData, ModalFormData } from "@minecraft/server-ui"
import { Admin_Main } from './main_menu'

world.beforeEvents.chatSend.subscribe((data) => {
    const player = data.sender
    const Message = data.message
    const ChatLock = world.getDynamicProperty('ChatLock')
    const PlayerName = player.getTags().filter(f => f.startsWith('PlayerName:')).map(e => e.slice(11))
    let Normal = player.getTags().filter(t => t.startsWith('PlayerName:'))
    if (player.hasTag('SpeakAsPlayer') && player.hasTag(`${Normal}`) && ChatLock === false) {
        world.sendMessage(`<${PlayerName}> ${Message}`)
        data.cancel = true
    } else if (player.hasTag('SpeakAsPlayer') && !player.hasTag(`${Normal}`) && ChatLock === false) {
        player.sendMessage('YOU DO NOT HAVE A PLAYER SELECTED!')
        data.cancel = true
    } else if (player.hasTag('SpeakAsPlayer') && !player.hasTag(`${Normal}`) && ChatLock === true) {
        data.cancel = true
        player.sendMessage('§c§lAn Admin Has Locked The Chat')
    }
})


export function Form(player) {
    const form = new ActionFormData()
    if (player.hasTag('SpeakAsPlayer')) {
        form.button('Speak As A Player\n[Enabled]')
    } else if (!player.hasTag('SpeakAsPlayer')) {
        form.button('Speak As A Player\n[Disabled]')
    }
    form.button('Back')
    form.show(player).then((data) => {
        if (data.selection === 0) {
            if (player.hasTag('SpeakAsPlayer')) {
                player.removeTag('SpeakAsPlayer')
                return Form(player)
            } else if (!player.hasTag('SpeakAsPlayer')) {
                player.addTag('SpeakAsPlayer')
                return Thingy(player)
            }
        }
        if (data.selection === 1) {
Admin_Main(player)
        }
    })

}




function Thingy(player) {
    const form = new ModalFormData()

        .textField(`Who Do You Want To Speak As`, "XxSheepDestroyerxX")

    form.show(player).then((data) => {

        player.addTag(`PlayerName:${data.formValues[0]}`)

    })
}




export function E(player) {
    const form = new ActionFormData()
    if (player.hasTag('SpeakAsPlayer')) {
        form.button('Speak As A Player\n[Enabled]')
    } else if (!player.hasTag('SpeakAsPlayer')) {
        form.button('Speak As A Player\n[Disabled]')
    }
    form.button('Edit Name')
    form.show(player).then((data) => {
        const TEST = player.getTags().filter(t => t.startsWith("PlayerName:"))
        if (data.selection === 0) {
            if (player.hasTag('SpeakAsPlayer')) {
                player.removeTag('SpeakAsPlayer')
                player.removeTag(`${TEST}`)
                return Form(player)
            } else if (!player.hasTag('SpeakAsPlayer')) {
                player.addTag('SpeakAsPlayer')
                return Thingy(player)
            }
        }
        if (data.selection === 1) {
            return Thingy2(player)
        }
    })

}
function Thingy2(player) {
    const PlayerName = player.getTags().filter(f => f.startsWith('PlayerName:')).map(e => e.slice(11))
    const form = new ModalFormData()

        .textField(`Who Do You Want To Speak As`, "XxSheepDestroyerxX", `${PlayerName}`)

    form.show(player).then((data) => {
        const TEST = player.getTags().filter(t => t.startsWith("PlayerName:"))
        player.removeTag(`${TEST}`)
        player.addTag(`PlayerName:${data.formValues[0]}`)

    })
}