import { ActionFormData, MessageFormData } from '@minecraft/server-ui';
import { world, system } from '@minecraft/server';
import { Main } from '../community_panel/main_menu';

//_________________________________/ Database \_________________________________\\

class DataBase {
    AnnouncementTitle = '';
    Announcement = '';

    constructor(DataBase) {
        if (!DataBase) return;
        Object.assign(this, DataBase);
    }
}

class Objectives {
    GetData(player) {
        // Retrieve the announcements from dynamic properties
        let storedData = world.getDynamicProperty('Announcement_DataStorage') || '[]';
        let Data = JSON.parse(storedData).map((item) => new DataBase(item));
        return Data;
    }

    SaveData(data) {
        // Save the announcements to dynamic properties
        let currentData = this.GetData();
        currentData.push(data);
        world.setDynamicProperty('Announcement_DataStorage', JSON.stringify(currentData));
    }

    RemoveData(data) {
        // Remove the specific data entry
        let currentData = this.GetData();
        currentData = currentData.filter((item) => item.AnnouncementTitle !== data.AnnouncementTitle);
        world.setDynamicProperty('Announcement_DataStorage', JSON.stringify(currentData));
    }
}

export const Objective = new Objectives();

//_________________________________/ Other Stuff \_________________________________\\

export function AnnouncementSelection(player) {
    let Datas = Objective.GetData(player);
    const form = new ActionFormData();
    form.title('Announcements!');
    for (let i = 0; i < Datas.length; i++) {
        let Data = Datas[i];
        form.button(`${Data.AnnouncementTitle}`);
    }
    form.button('Back');
    form.show(player).then((data) => {
        if (data.selection < Datas.length) {
            return Announcement(player, Datas, data.selection);
        }
        if (data.selection === Datas.length) {
            return Main(player);
        }
    });
}

function Announcement(player, Datas, index) {
    let Data = Datas[index];
    const form = new MessageFormData()
        .title(`${Data.AnnouncementTitle}`)
        .body(`${Data.Announcement}`);
    if (player.hasTag('Admin') || player.hasTag('admin')) {
        form.button1('Delete Announcement');
    } else {
        form.button1('Exit');
    }
    form.button2('Back');
    form.show(player).then((data) => {
        if (data.selection === 0) {
            if (player.hasTag('Admin') || player.hasTag('admin')) {
                system.run(() => {
                    Objective.RemoveData(Data);
                });
            }
        }

        if (data.selection === 1) {
            AnnouncementSelection(player);
        }
    });
}

// Initialize dynamic properties if not already set
if (!world.getDynamicProperty('Announcement_DataStorage')) {
    world.setDynamicProperty('Announcement_DataStorage', '[]');
}
